//
//  HFSReader.h
//  UDFKit
//
//  Created by Scott on 8/11/09.
//  Copyright 2009 The Little App Factory. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "UDFKit.h"
#import "HFSFileHandle.h"


@interface HFSReader : NSObject {

	NSString			*rootPath;
    BOOL				 closed;

    NSString			*pathToDevice;
    int					 fileDescriptor;
    int					 numberOfLayers;
    off_t				 rawBlockCount;
    BOOL				 isProtected;
    int					 regionMask;
    NSOperationQueue	*lockPicks;
    NSData				*encryptedDiscKey;
    NSData				*discKey;
    struct {
        uint16_t		 flags;
        NSString		*descriptor;
        off_t			 offset;
        uint32_t		 length;
    } volume;
    NSMutableDictionary	*cache;
    NSMutableDictionary	*titleKeysByPath;
	
}

@property (readonly) NSString* volumeDescription;
//@property (readonly) int regionMask;
@property (readonly) NSData* discKey;
@property (readonly) int numberOfLayers;
@property (assign) off_t rawBlockCount;
@property (readonly) BOOL closed;

- (void) close;
- (BOOL) fileExistsAtPath:(NSString*)path;
- (BOOL) fileExistsAtPath:(NSString*)path isDirectory:(BOOL*)isDirectory;
- (NSArray*) directoryContentsAtPath:(NSString*)path;
- (HFSFileHandle*) fileHandleForReadingAtPath:(NSString*)path;


@end
