#import "RIRipMode.h"
//#import "RIDiscPatchBuilder.h"


@class UDFReader;

@interface RIRipEngine : NSOperation {
    
	UDFReader		*reader;
	id				 delegate;
	
	// nsv
	RIRipMode		 ripMode;
	NSArray			*filterTitleSetArray;
	//RIDiscPatch		*discPatch;
	//RIDiscPatchBuilder *discPatchBuilder;

}

- (id) initWithUDFReader:(UDFReader*)reader;


@property (assign, nonatomic) id delegate; // NOT RETAINED
@property (readonly, nonatomic) UDFReader* reader;

// nsv
@property (assign) RIRipMode ripMode;
@property (retain) NSArray *filterTitleSetArray;
//@property (retain) RIDiscPatchBuilder *discPatchBuilder;

@end

@interface NSObject (RIRipEngineDelegate)
- (void) ripEngine:(RIRipEngine*)ripper queueSizeChanged:(unsigned int)size;
- (void) ripEngine:(RIRipEngine*)ripper didOpenFile:(NSString*)file ofLength:(uint64_t)length;
- (void) ripEngine:(RIRipEngine*)ripper didReadBlock:(NSData*)block fromOffset:(uint64_t)offset ofFile:(NSString*)file;
- (void) ripEngine:(RIRipEngine*)ripper didFailWithException:(id)exception;
- (void) ripEngineDidComplete:(RIRipEngine*)ripper usingPlanOfAttack:(NSDictionary*)planOfAttack;
@end

extern NSString* const RIRipEngineGeneralException;
extern NSString* const RIRipEngineReadErrorException;
