#import <Cocoa/Cocoa.h>
#import "RIRipEngine.h"
#import "DKDVDStructure.h"

@class RITitleSetExtraInformation;

@interface RIRipEngineV2 : RIRipEngine 
{	
	BOOL						 started;
	NSMutableArray				*infoCache;
	NSMutableDictionary			*handlesForReading;
    uint32_t					 totalLengthsInSectorsByTitle[100];
	uint32_t					 lengthsInSectorsByTitle[100][10];
	CFMutableBitVectorRef		 copiedSectorsByTitle[100][10];
    /**/
    int							 titleSetMax;
    int							 titleSetCount;
    uint8_t						 titleSetRemapTable[100];

	// nsv
	DKDVDStructure				*dvdStructure; 
    uint32_t					 ripStateByTitle[100];
    uint32_t					 totalLengthsInSecondsByTitle[100];
	
	unsigned long long			*totalBranchesExecuted;
	
	// nsv
#ifdef ENABLE_FORCE_ACTIVATED_BUTTON_REEXECUTE
	uint8_t						 forcedButtonVTS;
	uint32_t					 forcedButtonSector;
#endif
}


// nsv
@property (assign, readonly) DKDVDStructure *dvdStructure;

- (id) initWithUDFReader:(UDFReader*)reader;


@end
